variables:
   BUILD_VERSION: $CI_COMMIT_SHORT_SHA
   EW1_REGION: europe-west1
   EW2_REGION: europe-west2

# Describing different pipeline stages
stages:
 - checks
 - build
 - deploy

.image-name-script: &image-name-script
    - IMAGE_NAME=$GCP_AR/$GCP_PROJECT_ID/$GCP_AR_DIRECTORY/$API_NAME:v$BUILD_VERSION

# Checking code validity
.common_checks_template: &common_checks_template
  stage: checks
  image: node:14.15.0-alpine3.11
  script:
    - npm i

# Building Docker Image and pushing it to the GCP Artifact Registry
.build-and-push-docker-image-template: &build-and-push-docker-image-template
   stage: build
   image: docker:latest
   services:
     - docker:dind
   before_script:
     - echo $GCP_SERVICE_KEY | docker login -u _json_key --password-stdin https://$GCP_AR
   script:
     - *image-name-script
     - docker build -t $IMAGE_NAME -f Dockerfile .
     - echo $IMAGE_NAME
     - docker push $IMAGE_NAME
  
# Fetch the last build Docker Image and deploy a new version of the API in GCP Cloud Run
.cloud-run-deployment-template: &cloud-run-deployment-template
    stage: deploy
    image: google/cloud-sdk
    before_script:
      - echo $GCP_SERVICE_KEY > gcloud-service-key.json
      - gcloud auth activate-service-account --key-file gcloud-service-key.json
      - gcloud config set project $GCP_PROJECT_ID
    script:          
      - *image-name-script
      - gcloud run deploy $CLOUD_RUN_SERVICE --image=$IMAGE_NAME --region=$CLOUD_RUN_SERVICE_REGION

